
from Products.CMFCore.DirectoryView import addDirectoryViews, registerDirectory, createDirectoryView
from Products.CMFCore.TypesTool import  ContentFactoryMetadata, FactoryTypeInformation
from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod import ExternalMethod
from Globals import package_home
import os, string
    
ADD_CONTENT_PERMISSION = 'Add portal content'

def install_skin(self, outStream, skinName, skinFolder):
    """
    Provided by CMFExample (http://sourceforge.net/projects/collector
    """
    skinstool=getToolByName(self, 'portal_skins')
    path = skinstool.getSkinPath('Plone Default') 
    if not path:
        outStream.write('Plone skin not found, aborting\n')
        return
    path = map( string.strip, string.split( path,',' ) )

    if type(skinFolder)==type(''):
        skinFolder=(skinFolder, )

    for folder in skinFolder:
        try:
            path.insert( path.index( 'custom')+1, folder )
        except ValueError:
            path.append(folder)
	
    path = string.join( path, ', ' )
    skinstool.addSkinSelection( skinName, path )

def setup(self, out, modulename, globals, class_list):
    """
    Installs content classes and creates supporting skins. Derived from CMFExample
    """
    root=getToolByName(self, 'portal_url').getPortalObject()
    modulename=modulename[9:]
    #add skin
    skinstool=getToolByName(self, 'portal_skins')
    from Products.CMFCore import DirectoryView
    #
    # TO DO Skins kopieren und umbenennen
    #
    DirectoryView.registerDirectory('skins', globals)
    addDirectoryViews(skinstool, 'skins', globals)
    #install_skin(self, out, modulename, [ ('%s_views' % modulename) ] )
    install_skin(self, out, modulename, [ 'simple_views' ] )


    #adds the directory views to the END of all the other skins
    skin_map=skinstool._getSelections()
    for skin_name, skin_path in skinstool.getSkinPaths():
        if skin_name!=modulename:
            #skin_map[skin_name]=skin_path+('%s_views' % modulename)
            skin_map[skin_name]=skin_path+', simple_views'
            
    #add content types.  NOTE: need CMF1.3 or greater.
    typestool=getToolByName(self, 'portal_types')
    for i in class_list:
        typestool.manage_addTypeInformation( FactoryTypeInformation.meta_type
                                           , id=i.content_id
                                           , typeinfo_name=('%s: %s' % (modulename, i.meta_type)))

    # Register Navigation Transitions
    propTool=getToolByName(self, 'portal_properties')
    props=getattr(propTool, 'navigation_properties')
    for ctype in class_list:
        cname=ctype.content_id.lower()
        props._setProperty('%s.simplecontent_edit.success' % (cname, cname ), 'view', 'string')
        props._setProperty('%s.simplecontent_edit.failure' % (cname, cname ), 'edit', 'string')
    
#        
#    website=getattr(root, 'emerging')
#    website.manage_addProduct['SiteAccess'].manage_addAccessRule('setup_emerging')
#
#    o = website.site_catalog
#    website.site_catalog.ZopeFindAndApply( website
#                                         , obj_metatypes=('all',)
#					 , obj_ids=None
#					 , obj_searchterm=None
#					 , obj_expr=None
#					 , obj_mtime=None
#					 , obj_mspec=None
#					 , obj_permission=None
#					 , obj_roles=None
#					 , search_sub=1
#					 , REQUEST=None
#					 , apply_func=o.catalog_object
#					 , apply_path='/'.join(o.getPhysicalPath()))


def register(modulename, class_list, context_obj ):
    modulename=modulename[9:]
    from Products.CMFCore import CMFCorePermissions , utils
    constructors = []
    fti = []
    for i in class_list:
        constructor = i.constructor
        constructors.append(constructor)
        fti.append( { 'id'             : i.content_id
                    , 'meta_type'      : i.meta_type
                    , 'description'    : i.content_description
                    , 'icon'           : i.content_icon
                    , 'product'        : modulename
                    , 'factory'        : 'constructor'
                    , 'immediate_view' : 'metadata_edit_form'
                    , 'actions'        :
                     ( { 'id'            : 'view'
                                  , 'name'          : 'View'
                                  , 'action'        : 'simplecontent_view'
                                  , 'permissions'   : (
                                      CMFCorePermissions.View, )
                                  }
                                , { 'id'            : 'edit'
                                  , 'name'          : 'Edit'
                                  , 'action'        : 'simplecontent_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                                , { 'id'            : 'metadata'
                                  , 'name'          : 'Metadata'
                                  , 'action'        : 'metadata_edit_form'
                                  , 'permissions'   : (
                                      CMFCorePermissions.ModifyPortalContent, )
                                  }
                        )
                    },)
        utils.ContentInit( modulename
                     , content_types=tuple(class_list)
                     , permission=ADD_CONTENT_PERMISSION
                     , extra_constructors=tuple(constructors)
                     , fti=tuple(fti)
                     ).initialize( context_obj )
        