
from Products.CMFCore.PortalContent import PortalContent
from Products.CMFDefault.DublinCore import DefaultDublinCoreImpl
from OFS.PropertyManager import PropertyManager
# DefaultDublinCoreImpl is PropertyManager

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass
from DateTime import DateTime


def addClass(self, id=None, theClass=None, REQUEST=None):
    "Add an arbitrary class to a folder to a folder."
    # if no id passed, generate one from the datetime
    if id == None:
        id = DateTime().strftime('%Y%m%d_%H%M%S')
    self._setObject(id, theClass(id))
    if REQUEST is not None:
        getattr(self, id).manage_changeProperties(REQUEST)
        #return self.manage_main(self, REQUEST)


class SimpleContent(PortalContent, DefaultDublinCoreImpl):

    meta_type = 'Simple Content'

    __implements__ = PortalContent.__implements__ + DefaultDublinCoreImpl.__implements__
    
    manage_options = PropertyManager.manage_options + PortalContent.manage_options


    security = ClassSecurityInfo()

    _properties = {}
    

    def getProperties( self ):
        """ return the otherwise protected property dictionary"""
        return self._properties

    def __init__( self, id  ):
        """ constructor"""
        DefaultDublinCoreImpl.__init__(self)
        self.id=id
        self._defaults()

    def _defaults(self):
        """
        Set default attributes in current object
        for all properties in '_properties'
        """
        defaults = {
            'float'              : 0.0,
            'int'                : 0,
            'long'               : 0L,
            'date'               : DateTime(),
            'string'             : '',
            'text'               : '',
            'boolean'            : 0,
            'lines'              : [],
            'tokens'             : [],
            'selection'          : [],
            'multiple selection' : [],
        }
        for prop in self._properties:
            if prop['type'] in defaults.keys():
                setattr(self, prop['id'], defaults[prop['type']])
            else:
                raise TypeError, '"%s" is illegal type for propertysheet' % prop['type']

    def SearchableText(self):
        "Returns a concatination of all searchable text"
        # Should be overriden by portal objects
        return str(self)
    
    def __str__(self):
        """
        Returns all text in the objects properties
        """
        result = [ self.Title(), self.Description(), ]
        for dct in self._properties:
            if dct['type'] in ['string', 'text']:
                result.append(getattr(self, dct['id']))
        return ' '.join(result)

    def edit(self, REQUEST):
        "Does the editing"
        self.manage_changeProperties(REQUEST)
        self.reindex_object()

        

InitializeClass(SimpleContent)


    
